package org.jeecg.modules.stm.wb.survey.controller;

import java.util.Arrays;
import java.util.List;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.survey.entity.WbKeyName;
import org.jeecg.modules.stm.wb.survey.service.IWbKeyNameService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 第三方接口项表
 * @Author: jeecg-boot
 * @Date:   2024-05-28
 * @Version: V1.0
 */

@RestController
@RequestMapping("/wb.survey/wbKeyName")
@Slf4j
public class WbKeyNameController extends JeecgController<WbKeyName, IWbKeyNameService> {
	@Autowired
	private IWbKeyNameService wbKeyNameService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbKeyName
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "第三方接口项表-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<WbKeyName>> queryPageList(WbKeyName wbKeyName,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbKeyName> queryWrapper = QueryGenerator.initQueryWrapper(wbKeyName, req.getParameterMap());
		Page<WbKeyName> page = new Page<WbKeyName>(pageNo, pageSize);
		IPage<WbKeyName> pageList = wbKeyNameService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbKeyName
	 * @return
	 */
	@AutoLog(value = "第三方接口项表-添加")

	@RequiresPermissions("wb.survey:wb_key_name:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbKeyName wbKeyName) {
		wbKeyNameService.save(wbKeyName);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbKeyName
	 * @return
	 */
	@AutoLog(value = "第三方接口项表-编辑")

	@RequiresPermissions("wb.survey:wb_key_name:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbKeyName wbKeyName) {
		wbKeyNameService.updateById(wbKeyName);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "第三方接口项表-通过id删除")

	@RequiresPermissions("wb.survey:wb_key_name:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbKeyNameService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "第三方接口项表-批量删除")

	@RequiresPermissions("wb.survey:wb_key_name:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbKeyNameService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "第三方接口项表-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<WbKeyName> queryById(@RequestParam(name="id",required=true) String id) {
		WbKeyName wbKeyName = wbKeyNameService.getById(id);
		if(wbKeyName==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbKeyName);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbKeyName
    */
    @RequiresPermissions("wb.survey:wb_key_name:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbKeyName wbKeyName) {
        return super.exportXls(request, wbKeyName, WbKeyName.class, "第三方接口项表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.survey:wb_key_name:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbKeyName.class);
    }


	 //@AutoLog(value = "调查配置-通过apiid查询")

	 @GetMapping(value = "/queryApiItemByApiCode")
	 public Result<List<WbKeyName>> queryApiItemByApiCode(@RequestParam(name="code",required=true) String code) {
		 QueryWrapper<WbKeyName> queryWrapper = new QueryWrapper<>();
		 queryWrapper.eq("api_id",code);
		 List<WbKeyName> list = wbKeyNameService.list(queryWrapper);
		 if(list==null) {
			 return Result.error("未找到对应数据");
		 }
		 return Result.OK(list);
	 }

}
